
#include <d3d9.h>
#include <d3dx9.h>


#ifndef _RENDER_H_
#define _RENDER_H_

namespace Render {

// ---------------------------------------------------------------------------
// _Ot[obt@̃TCY
// ---------------------------------------------------------------------------
#if 0
	enum{
		RENDER_WIDTH  = 32,
		RENDER_HEIGHT = 32,
	};
#else
#if 1
	enum{
		RENDER_WIDTH  = 256,
		RENDER_HEIGHT = 256,
	};
#else
	enum{
		RENDER_WIDTH  = 512,
		RENDER_HEIGHT = 512,
	};
#endif

#endif

// ---------------------------------------------------------------------------
// Oǂݍފ֐
// ---------------------------------------------------------------------------
void Init();			// 
void Delete();			// Еt
void Render();			// `
char *GetDataPointer();	// t[obt@̏

// ---------------------------------------------------------------------------
// uIuWFNg̎
// ---------------------------------------------------------------------------
enum {
	OBJ_TYPE_SPHERE = 0,
	OBJ_TYPE_TRIANGLE,
};
// ---------------------------------------------------------------------------
// ̂߂̃f[^
// ---------------------------------------------------------------------------

// 
typedef struct{
	float	COLOR_AMB[4];	// F
	float	COLOR_DIF[4];	// gUF
	float	COLOR_SPE[4];	// ʔːF
	float	speq_power;		// ʔ˂̋
}Material;
// ---------------------------------------------------------------------------
typedef struct{
	int type;

	Material material;
	
	struct{
		// 3p`
		float x0[3];	// WP
		float x1[3];	// WQ
		float x2[3];	// WR
	} triangle;
	struct {
		// ʗp
		float center[3];// S
		float radius;	// a
	} sphere;

}OBJ_DATA;

// ---------------------------------------------------------------------------
class CObject
{
public:
	enum {
		INFINTY_DIST = 10000,	// Ƃ݂Ȃx̋
	};
	int m_type;					// OBJ_TYPE_????
	Material m_material;		// 

	// 
	void Init(OBJ_DATA *pData);
	// 
	float IsAcross(D3DXVECTOR4 *n, D3DXVECTOR4 *p, const D3DXVECTOR4 *x, const D3DXVECTOR4 *v){return INFINTY_DIST;}
	// f[^AIuWFNg̐F𓾂
	D3DXVECTOR3 *GetColor(D3DXVECTOR3 *dest, float LN, float HN );
};
// ---------------------------------------------------------------------------
// 
// ---------------------------------------------------------------------------
class CSphere : public CObject
{
private:
	D3DXVECTOR4 center;	// S
	float radius_sq;	// a

public:
	CSphere();

	void Init(OBJ_DATA *pData);
	float IsAcross(D3DXVECTOR4 *n, D3DXVECTOR4 *p, const D3DXVECTOR4 *x, const D3DXVECTOR4 *v);
};

// ---------------------------------------------------------------------------
// Rp`
// ---------------------------------------------------------------------------
class CTriangle : public CObject
{
private:
	D3DXVECTOR4 pos[3];			// _W
	D3DXVECTOR4 normal;			// @xNg

public:
	CTriangle();

	void Init(OBJ_DATA *pData);
	float IsAcross(D3DXVECTOR4 *n, D3DXVECTOR4 *p, const D3DXVECTOR4 *x, const D3DXVECTOR4 *v);
};

};// namespace Render

#endif // !_RENDER_H_